function [brainMask3] = BrainExtraction(cleanIm, MPRAGE)
%Initialize Variables
brainMask = MPRAGE;
%% Peform loop making all values in MRI file above the skull 0
for i = 1:length(cleanIm(1,1,:)) %go through z
    for j = 1:length(cleanIm(1,:,1)) %go through x
        for k = 1:length(cleanIm(:,1,1)) %go through y down from the top
            if cleanIm(k,j,i) == 1 %if the value in the skull mask is 1
                break
            else
                brainMask(k,j,i) = 0;
            end
        end
    end
end
frame = 41;
figure;
imshow(brainMask(:,:,frame),[]), truesize([600 600]);title(["zFrame=",num2str(frame)]);

%% Perform loop to zero out the skull areas and find the brain
threshold = input('Enter threshold for brain isolation:  ');
brainMask2 = brainMask;
for i = 1:length(cleanIm(1,1,:)) %go through z
    for j = 1:length(cleanIm(1,:,1)) %go through x
        for k = 1:length(cleanIm(:,1,1)) %go through y down from the top
            if cleanIm(k,j,i) == 1 %if the value in the skull mask is 1
                brainMask(k,j,i) = 0;
                %                 brainMask2(k,j,i) = 0;
            else
                brainMask(k,j,i) = brainMask(k,j,i);
            end
            if  brainMask(k,j,i) >= threshold %brainMask (k,j,i) ~= 0 &&
                brainMask2(k,j,i) = 1;
            else
                brainMask2(k,j,i) = 0;
            end
        end
    end
end

figure;
imshow(brainMask(:,:,frame),[]), truesize([600 600]);title(["zFrame=",num2str(frame)]);
figure
imshow(brainMask2(:,:,frame),[]), truesize([600 600]);title(["zFrame=",num2str(frame)]);

% Confirm threshold
disp('Is this the threshold you would like to continue with (y)es or (n)o? : ');
check = input('','s');
while check ~= 'y'
    threshold = input('Enter threshold for brain isolation:  ');
    brainMask2 = brainMask;
    for i = 1:length(cleanIm(1,1,:)) %go through z
        for j = 1:length(cleanIm(1,:,1)) %go through x
            for k = 1:length(cleanIm(:,1,1)) %go through y down from the top
                if cleanIm(k,j,i) == 1 %if the value in the skull mask is 1
                    brainMask(k,j,i) = 0;
                    %                 brainMask2(k,j,i) = 0;
                else
                    brainMask(k,j,i) = brainMask(k,j,i);
                end
                if  brainMask(k,j,i) >= threshold %brainMask (k,j,i) ~= 0 &&
                    brainMask2(k,j,i) = 1;
                else
                    brainMask2(k,j,i) = 0;
                end
            end
        end
    end

    figure;
    imshow(brainMask(:,:,frame),[]), truesize([600 600]);title(["zFrame=",num2str(frame)]);
    figure;
    imshow(brainMask2(:,:,frame),[]), truesize([600 600]);title(["zFrame=",num2str(frame)]);
    
    % Confirm threshold
    disp('Is this the threshold you would like to continue with (y)es or (n)o? : ');
    check = input('','s');
end
%% Convert to double
brainMask3 = double(brainMask2);

end